% demo to show the call of ICA by entropy rate bound minimization (ICA-ERBM) algorithm
clear
close all

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% In this demo, the sources are outputs of ARMA models driven by i.i.d. signals of Gamma 
% distribution
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%%%%%%%%%%%%%%%%%%%%%%%%%%
% generate sources
%%%%%%%%%%%%%%%%%%%%%%%%%
alpha = 1:1:10;
N = length(alpha);
T = 1000;

for n = 1 : N
    s(n,:) = gamrnd(alpha(n),1,1,T);
end

for n = 1 : N
    
    b = randn(3,1);
    s(n,:) = filter(b, 1, s(n,:));
    
end
%s(1,:) = sin(0.1*2*pi*(1:T))+sin(0.213*2*pi*(1:T))/1.71;   % for signal with minus inf entropy rate, take care 

for n = 1 : N
    s(n,:) = s(n,:) - mean(s(n,:));
    s(n,:) = sqrt(T)*s(n,:)/norm(s(n,:));  
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% generate mixtures
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
A = randn(N,N); 
x = A*s;
%%%%%%%%%%%%%%%%%%%%%%%%%%

%%%%%%%%%%%%%%%%%%%%%%
% call ICA-ERBM
W1 = ERBM(x,3);  
figure;
T = W1*A;
%T = W1*inv(W2);
for n=1:N
    T(n,:)=T(n,:)/(max(abs(T(n,:))));
end
T=kron(T,ones(50,50));
imshow(abs(T))
title('Confusion matrix')








